/*
**	dft and inversed impulse responce
*/

#include <stdio.h>
#include <math.h>

#define N 512

static float x[N]= { 1 };
//static float x[N]= { .51, .5 };
//static float x[N]= { .26, .5, .25 };
//static float h[N]= { .51, .5 };
//static float h[N]= { .26, .5, .25 };

static float h[N]= { .125, .375, .375, .125 };
static float y[N];	// inversed impulse response
static float z[N];
static float c[N]= {1.,0,0};
static float Xr[N];
static float Xi[N];

static void
dft()
{
	int i,j;
	for(j=0;j<=N/2;j++){
		Xr[j]= Xi[j]= 0;
		for(i=0;i<N;i++){
			double t= -2*M_PI*i*j/N;
			Xr[j]+= x[i]*cos(t);
			Xi[j]+= x[i]*sin(t);
		}
		z[j]= sqrt(Xr[j]*Xr[j]+Xi[j]*Xi[j]);
	}
	for(j=0;j<=N/2;j++) printf("%f\n",z[j]);
	
}

/*
**	polynominal inversion
**	in: c[]: impulse signal
**	in: h[]: original forward impulse response
**	out: y[]: inverted impulse responce
*/
static void
pol_inv(float*c, float*h, float*y)
{
	int i,j;

	for(i=0;i<N;i++){
		y[i]= c[i]/h[0];
		for(j=i+1;j<N;j++) c[j]-= y[i]*h[j-i];
	}
	for(j=0;j<N;j++) printf("%f\n",y[j]);

	/* test XY= 1 
	for(j=0;j<N;j++) {
		double t= 0;
		for(i=0;i<10;i++) t+= x[i]*y[j-i];
		z[j]= t;
	}
	for(j=0;j<N;j++) printf("%f\n",z[j]);
	*/
}


float ac[N];
/*
**	acor():	auto-correlation
**	in: s, analizing length n
**	out: ac[]
*/
acor(int n,float *s,float *ac)
{
	int i,j; double t;
	for(j=0;j<n;j++) {
		t= 0; for(i=0;i<n-j;i++) t+= s[i]*s[i+j];
		ac[j]= t/n;
		//printf("%f\n",ac[j]);
	}
}

/*
**	lpc():	calc alpha and k parameters (Levinson and Durbin)
**	ac[N] to al[N], kp[N];
*/
static void
lpc(int n,float *ac,float *al, float *kp)
{
	int i,j;
	double u,w,k,t;

	al[0]= 1.;
	al[1]= 0.;
	w= ac[1];
	u= ac[0];
	for(j=1;j<= n;j++){
		k= kp[j]= w/u;
		u-= k*w;
		al[j]= -k;
		if(j>1){
			if(j>2) for(i=1;i<(j+1)/2;i++) { t= al[i]; al[i]-= k*al[j-i]; al[j-i]-= k*t; }
			if(!(j&1)) al[j/2]*= 1.- k;
		}
		w= 0.; for(i=0;i<=j;i++) w+= al[i]*ac[j+1-i];
	}
	//for(i=0;i<n;i++) ipl[i]= -al[i]*(1<<14);
	for(i=0;i<n;i++) printf("%f\n", al[i]);
}

static void
trim_h()
{
	int i;
	//h[0]*= 1.004;
	for(i=0;i<N;i++) h[i]*= exp(-i*0.01);
}

static void
iir()
{
	int i,j;
	double ih0= 1./h[0];

	for(i=0;i<N;i++){
		double t= x[i]; 
		for(j=1;j<=3;j++) t-= h[j] * y[i-j];
		y[i]= t*ih0;
	}
	for(i=0;i<N;i++) printf("%f\n",y[i]);
}

int
main()
{
	trim_h();
	//iir();
	pol_inv(c,h,y);

	//dft();
	//acor(N, h, ac); lpc(N, ac, y, z);
	return 0;
}
